eshoplogistic2.panel.OrderDelivery = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'eshoplogistic2-order-delivery-panel';
    }
    Ext.applyIf(config, {
        layout: 'form',
        cls: 'main-wrapper',
        defaults: {msgTarget: 'under', border: false},
        anchor: '100% 100%',
        border: false,
        url: eshoplogistic2.config.connector_url,
        items: this.getFields(config),
        listeners: {
            afterrender: function() {
                this.getData(config)
            }
        },
        pageSize:10,
        paging: true,
        remoteSort: true,
        autoHeight: true
    });
    
    eshoplogistic2.panel.OrderDelivery.superclass.constructor.call(this, config);
};

Ext.extend(eshoplogistic2.panel.OrderDelivery, MODx.Panel, {
    
    getData: function(config) {
        const _self = this,
            fields = ['price','time','service','mode','address']

	    MODx.Ajax.request({
            url: eshoplogistic2.config.connector_url,
            params: {
		        action: 'mgr/order',
                order_id: config['order_id'] || 0,
            },
            listeners: {
		        success: {
                    fn: function (response) {
                        for (var i in fields) {
                            if (!fields.hasOwnProperty(i)) {
                                continue;
                            }
                            if(typeof response.delivery[fields[i]] !== 'undefined') {
                                let elem = Ext.getCmp('eshoplogistic2-order-delivery-' + fields[i])
                                elem.setValue(response.delivery[fields[i]])
                            }
                        }
                    }, scope: this
		        }
            }
	    });
    },

    getFields: function (config) {
        return [{
            layout: 'column',
            items: [{
                    columnWidth: 1,
                    layout: 'form',
                    items: [{
                        xtype: 'displayfield',
                        id: 'eshoplogistic2-order-info',
                        html: '<p>'+_('eshoplogistic2_order_delivery_info')+'</p>'
                    }]
                },{
                columnWidth: .2,
                layout: 'form',
                defaults: {anchor: '100%', hideLabel: false},
                items:[{
                    xtype: 'textfield',
                    id: 'eshoplogistic2-order-delivery-price',
                    readOnly: true,
                    //emptyText: '?',
                    value: '1000 h',
                    fieldLabel: _('eshoplogistic2_order_delivery_info_price')
                },{
                    xtype: 'textfield',
                    id: 'eshoplogistic2-order-delivery-time',
                    readOnly: true,
                    fieldLabel: _('eshoplogistic2_order_delivery_info_time')
                }]
            },{
                columnWidth: .8,
                layout: 'form',
                defaults: {anchor: '100%', hideLabel: false},
                items:[{
                    xtype: 'textfield',
                    id: 'eshoplogistic2-order-delivery-service',
                    readOnly: true,
                    fieldLabel: _('eshoplogistic2_order_delivery_info_service')
                },{
                    xtype: 'textfield',
                    id: 'eshoplogistic2-order-delivery-mode',
                    readOnly: true,
                    fieldLabel: _('eshoplogistic2_order_delivery_info_mode')
                },{
                    xtype: 'textfield',
                    id: 'eshoplogistic2-order-delivery-address',
                    readOnly: true,
                    fieldLabel: _('eshoplogistic2_order_delivery_info_pvz')
                }]
            }]
        }];
    },
    
});
Ext.reg('eshoplogistic2-order-delivery-panel', eshoplogistic2.panel.OrderDelivery);
