<?php
class Delivery 
{
	public $modx;
    public $eshoplogistic2;
	public $data = [
		'mode' => '',
		'service' => '',
		'payment' => '',
		'fias' => ''
	];

	
    function __construct($eshoplogistic2) 
	{
        $this->eshoplogistic2 = &$eshoplogistic2;
        $this->modx = &$eshoplogistic2->modx;
    }
	
	
	
	
	public function Process($data=[]) 
	{				
		$out = [
		    'price' => 0,
            'time' => '',
            'mode' => '',
            'service' => '',
            'address' => '',
            'comment' => ''
        ];


		if(!empty($data['delivery'])) {
            if ($data = json_decode($data['delivery'], 1)) {

                $out['price'] = (double)$data['price'];
                $out['time'] = $data['time'] ?? '';
                $out['address'] = $data['address'] ?? '';
                $out['comment'] = $data['comment'] ?? '';

                if (!empty($data['key'])) {
                    $out['service'] = $this->modx->lexicon('eshoplogistic2_frontend_service_' . $data['key']);
                    if($data['key'] == 'postrf') {
                        $out['mode'] = $this->modx->lexicon('eshoplogistic2_frontend_mode_postrf');
                    }
                }

                if(!empty($data['mode']) && empty($out['mode'])) {
                    $out['mode'] = $this->modx->lexicon('eshoplogistic2_frontend_mode_' . $data['mode']);
                }

                if ($this->ms2Init()) {
                    $this->ms2->order->add('esl_data', json_encode($out));

                    $order_data = $this->ms2->order->get();

                    if(empty($order_data['payment'])) {
                        if ($delivery = $this->modx->getObject('msDelivery', $order_data['delivery'])) {
                            $payment_id = $delivery->getFirstPayment();

                        }
                    } else {
                        $payment_id = $order_data['payment'];
                    }

                    if(!empty($payment_id)) {
                        if($payment = $this->modx->getObject('msPayment', $payment_id)) {
                            $out['payment'] = $payment->name;
                        }
                    }
                }
            }
        }

		return $out;
	}



    private function ms2Init()
    {
        if(is_dir($this->modx->getOption('core_path').'components/minishop2/model/minishop2/')) {

            $this->ms2 = $this->modx->getService('miniShop2');

            if ($this->ms2 instanceof miniShop2) {

                $context = $this->modx->context->key ? $this->modx->context->key : 'web';

                $this->ms2->initialize($context, ['json_response' => true]);

                return true;
            }
        }

        return false;
    }

}