<?php

class eshoplogistic2ActionProcessor extends modProcessor 
{
    public $permission = '';
	public $eshoplogistic2;
	public $query;
	
    public function process()   
	{
        $out = [];

        $this->eshoplogistic2 = $this->modx->getService('eshoplogistic2');
		
		if(!empty($_POST['text'])) {
			$this->query = ['target' => $_POST['text']];
			$out = $this->Address();
		}
        elseif(!empty($_POST['cart'])) {
		    $offers = $this->eshoplogistic2->getOffers('cart');
            return $offers;
        }
		elseif(!empty($_POST['secret'])) {
			$out = $this->eshoplogistic2->Run('order');
		}
		else {
			if(!empty($_POST['delivery'])) {
				$out = $this->Delivery();
			}
		}			
		
        return $this->modx->toJSON($out);
    }
	
	
	
	
	private function Delivery() 
	{
		if($esl_delivery = $this->eshoplogistic2->Run('delivery', @$_POST)) {
			return $esl_delivery;
		}

		return [];
	}
	
	
	
	
	private function Address() 
	{
        $list = [];
				
		$response = $this->eshoplogistic2->Query('search', $this->query);

		if(!empty($response['data'])) {
								
			foreach ($response['data'] as $item) {

				if(!empty($item['fias'])) {	

					$target = $item['type'].' '.$item['name'];
					
					if(!empty($item['region'])) {
						$target .= ', '.$item['region'];
					}
					if(!empty($item['subregion'])) {
						$target .= ', '.$item['subregion'];
					}

					$list[] = [
						'fias' => $item['fias'],
                        'type' => $item['type'],
						'index' => $item['postal_code'] ?? '',
                        'name' => $item['name'],
						'target' => $target,
                        'services' => $item['services']
					];
				}
			}
		}
			
		return $list;
	}
	
}

return 'eshoplogistic2ActionProcessor';
